import React, { PureComponent } from 'react';

export default class SceneView extends PureComponent {
  static childContextTypes = {
    navigation: React.PropTypes.object.isRequired
  };

  getChildContext() {
    return {
      navigation: this.props.navigation
    };
  }

  componentWillMount() {
    if (this.props.screenProps !== undefined && !this.props.hideScreenPropsWarning) {
      console.warn('Behaviour of screenProps has changed from initial beta. ' + 'Components will now receive it as `this.props.screenProps` instead.\n' + 'Pass `hideScreenPropsWarning` to hide this warning.');
    }
  }

  render() {
    const {
      hideScreenPropsWarning,
      screenProps,
      navigation,
      component: Component
    } = this.props;

    return <Component hideScreenPropsWarning={hideScreenPropsWarning} screenProps={screenProps} navigation={navigation} />;
  }
}